package lib

import (
	"fmt"
	"log"
	"os"
	"path/filepath"
	"strings"

	"github.com/schollz/progressbar/v3"
)

func GatewayStaticDirSet(domain, dirname, gatewayPath string) {
	if domain == "" {
		panic(fmt.Errorf("domain name should be set"))
	}
	bar := progressbar.Default(-1, "Files in dirs")
	err := filepath.Walk(dirname,
		func(path string, info os.FileInfo, err error) error {
			if !info.IsDir() {
				if err != nil {
					return err
				}
				GatewayStaticFileSet(path, domain, strings.ReplaceAll(fmt.Sprintf(`%s/%s`, gatewayPath, path), "//", "/"))
				bar.Add(1)
			}
			return nil
		})
	if err != nil {
		log.Println(err)
	}
}
