package lib

import (
	"encoding/json"
	"fmt"
	"net/http"
	"os"
)

type StaticContent struct {
	ContentType string `json:"contentType"`
	Content     []byte `json:"content"`
}

func GatewayStaticFileSet(filename, domain, gatewayPath string) {
	var err error

	if _, err = os.Stat(filename); err != nil {
		panic(err)
	}

	if domain == "" {
		panic(fmt.Errorf("domain name should be set"))
	}

	var file []byte

	file, err = os.ReadFile(filename)
	if err != nil {
		panic(err)
	}

	paths := map[string]map[string]StaticContent{
		domain: {
			gatewayPath: StaticContent{
				ContentType: http.DetectContentType(file),
				Content:     file,
			},
		},
	}

	var payload []byte
	if payload, err = json.Marshal(paths); err != nil {
		panic(nil)
	}
	if _, _, err = client.Call("system.gateway.setRouteStatic", nil, payload); err != nil {
		panic(err)
	}
}
