package lib

import (
	"encoding/json"

	"git.ymnuktech.ru/ymnuk/yt-cli/structs"

	"github.com/schollz/progressbar/v3"
)

func SecuritySet(security *structs.Security) {
	if security.Uri != nil {
		// Установить настройку URI для проекта
		if _, _, err := client.Call("system.security.setUri", nil, []byte(*security.Uri)); err != nil {
			panic(err)
		}

	}
	if security.Redirect != nil {
		// Установить настройку Redirect для проекта
		if _, _, err := client.Call("system.security.setRedirect", nil, []byte(*security.Redirect)); err != nil {
			panic(err)
		}
	}
	if security.Func != nil {
		// Установить настройку func для проекта
		if _, _, err := client.Call("system.security.setFunc", nil, []byte(*security.Func)); err != nil {
			panic(err)
		}
	}
	if security.Rbac != nil {
		SecuritySetRbac(security.Rbac)
	}
	if len(security.Users) > 0 {
		bar := progressbar.Default(int64(len(security.Users)), "Users")
		for _, user := range security.Users {
			var payload []byte
			var err error
			payload, err = json.Marshal(user)
			if err != nil {
				panic(err)
			}
			if _, _, err := client.Call("system.security.setUser", nil, payload); err != nil {
				panic(err)
			}
			bar.Add(1)
		}
	}
}

func SecuritySetRbac(rbac *structs.Rbac) {
	// TODO
	if rbac == nil {
		return
	}
	/*payload, err := json.Marshal(rbac)
	if err != nil {
		return
	}*/

	if len(rbac.Roles) > 0 {
		bar := progressbar.Default(int64(len(rbac.Roles)), "RBAC roles")
		for _, role := range rbac.Roles {
			payload, err := json.Marshal(role)
			if err != nil {
				panic(err)
			}
			if _, _, err = client.Call("system.security.setRole", nil, payload); err != nil {
				panic(err)
			}
			bar.Add(1)
		}
	}

	if len(rbac.Groups) > 0 {
		bar := progressbar.Default(int64(len(rbac.Roles)), "RBAC groups")
		for _, group := range rbac.Groups {
			payload, err := json.Marshal(group)
			if err != nil {
				panic(err)
			}
			if _, _, err = client.Call("system.security.setGroup", nil, payload); err != nil {
				panic(err)
			}
			bar.Add(1)
		}
	}

	/*if _, _, err = client.Call("system.security.setrbac", nil, payload); err != nil {
		panic(err)
	}*/

}
