package main

import "git.ymnuktech.ru/ymnuk/yt-cli/lib"

func init() {
	lib.LoadConfig()

}

func main() {
	lib.ClientRun()
	defer lib.ClientSutdown()

	if lib.AppConfig.ParamList {
		lib.ConfigList()
	} else if lib.AppConfig.ParamSet {
		if err := lib.ConfigSet(lib.AppConfig.ParamName, lib.AppConfig.ParamValue); err != nil {
			panic(err)
		}
	} else if lib.AppConfig.ParamGet {
		if err := lib.ConfigGet(lib.AppConfig.ParamName); err != nil {
			panic(err)
		}
	}

	if lib.AppConfig.GatewayFuncSet {
		lib.GatewayFuncSet(lib.AppConfig.Domain, lib.AppConfig.Method, lib.AppConfig.GatewayFuncName, lib.AppConfig.GatewayPath)
	} else if lib.AppConfig.GatewayProxySet {
		lib.GatewayProxySet(lib.AppConfig.Domain, lib.AppConfig.GatewayProxyAddr, lib.AppConfig.GatewayPath)
	} else if lib.AppConfig.GatewayStaticSet {
		lib.GatewayStaticFileSet(lib.AppConfig.Domain, lib.AppConfig.Filename, lib.AppConfig.GatewayPath)
	} else if lib.AppConfig.GatewayStaticDirSet {
		lib.GatewayStaticDirSet(lib.AppConfig.Domain, lib.AppConfig.Dirname, lib.AppConfig.GatewayPath)
	} else if lib.AppConfig.ParamFile {
		lib.ConfigUpload(lib.AppConfig.Filename)
	} else if lib.AppConfig.VerifyAccessToken {
		lib.SetToken(lib.AppConfig.Domain, lib.AppConfig.VerifyAccessTokenPath)
	} else if lib.AppConfig.CallFunction != "" {
		lib.CallFunction(lib.AppConfig.CallFunction)
	} else {
		lib.PrintHelp()
	}
}
